/* ToucheggSettings.c generated by valac 0.56.18, the Vala compiler
 * generated from ToucheggSettings.vala, do not modify */

/*
 * Copyright (c) 2020 elementary, Inc. (https://elementary.io)
 *               2020 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "mouse-touchpad.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <glib/gstdio.h>

#define MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_SETTINGS_XPATH "//application[@name=\"All\"]"
#define MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_MAXIMIZE_3_XPATH "//application[@name=\"All\"]/gesture[@fingers=\"3\"]/action[@type=\"MA" \
"XIMIZE_RESTORE_WINDOW\"]/.."
#define MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_MAXIMIZE_4_XPATH "//application[@name=\"All\"]/gesture[@fingers=\"4\"]/action[@type=\"MA" \
"XIMIZE_RESTORE_WINDOW\"]/.."
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_0_PROPERTY,
	MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_ERRORS_PROPERTY,
	MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* mouse_touchpad_touchegg_settings_properties[MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _xmlXPathFreeContext0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeContext (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _xmlFreeDoc0(var) ((var == NULL) ? NULL : (var = (xmlFreeDoc (var), NULL)))
#define _xmlXPathFreeObject0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeObject (var), NULL)))
#define _xmlFreeNode0(var) ((var == NULL) ? NULL : (var = (xmlFreeNode (var), NULL)))

struct _MouseTouchpadToucheggSettingsPrivate {
	gboolean _errors;
	gchar* system_config_path;
	gchar* user_config_dir_path;
	gchar* user_config_path;
};

static gint MouseTouchpadToucheggSettings_private_offset;
static gpointer mouse_touchpad_touchegg_settings_parent_class = NULL;

static gchar* mouse_touchpad_touchegg_settings_build_maximize_xml (gint fingers);
static void mouse_touchpad_touchegg_settings_save_config (MouseTouchpadToucheggSettings* self,
                                                   const gchar* xpath_expression,
                                                   gboolean enabled,
                                                   gchar** xml_settings,
                                                   gint xml_settings_length1);
static gboolean mouse_touchpad_touchegg_settings_user_config_exists (MouseTouchpadToucheggSettings* self);
static void mouse_touchpad_touchegg_settings_set_errors (MouseTouchpadToucheggSettings* self,
                                                  gboolean value);
static void mouse_touchpad_touchegg_settings_remove_matching_nodes (xmlXPathContext* ctx,
                                                             const gchar* xpath_expression);
static void mouse_touchpad_touchegg_settings_append_xml (xmlNode* node,
                                                  const gchar* xml,
                                                  GError** error);
static void mouse_touchpad_touchegg_settings_finalize (GObject * obj);
static GType mouse_touchpad_touchegg_settings_get_type_once (void);
static void _vala_mouse_touchpad_touchegg_settings_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_mouse_touchpad_touchegg_settings_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
mouse_touchpad_touchegg_settings_get_instance_private (MouseTouchpadToucheggSettings* self)
{
	return G_STRUCT_MEMBER_P (self, MouseTouchpadToucheggSettings_private_offset);
}

MouseTouchpadToucheggSettings*
mouse_touchpad_touchegg_settings_construct (GType object_type)
{
	MouseTouchpadToucheggSettings * self = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 38 "../src/Utils/ToucheggSettings.vala"
	self = (MouseTouchpadToucheggSettings*) g_object_new (object_type, NULL);
#line 39 "../src/Utils/ToucheggSettings.vala"
	_tmp0_ = g_build_filename (G_DIR_SEPARATOR_S, "usr", "share", "touchegg", "touchegg.conf", NULL);
#line 39 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (self->priv->system_config_path);
#line 39 "../src/Utils/ToucheggSettings.vala"
	self->priv->system_config_path = _tmp0_;
#line 40 "../src/Utils/ToucheggSettings.vala"
	_tmp1_ = g_get_home_dir ();
#line 40 "../src/Utils/ToucheggSettings.vala"
	_tmp2_ = g_build_filename (_tmp1_, ".config", "touchegg", NULL);
#line 40 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (self->priv->user_config_dir_path);
#line 40 "../src/Utils/ToucheggSettings.vala"
	self->priv->user_config_dir_path = _tmp2_;
#line 41 "../src/Utils/ToucheggSettings.vala"
	_tmp3_ = g_get_home_dir ();
#line 41 "../src/Utils/ToucheggSettings.vala"
	_tmp4_ = g_build_filename (_tmp3_, ".config", "touchegg", "touchegg.conf", NULL);
#line 41 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (self->priv->user_config_path);
#line 41 "../src/Utils/ToucheggSettings.vala"
	self->priv->user_config_path = _tmp4_;
#line 38 "../src/Utils/ToucheggSettings.vala"
	return self;
#line 145 "ToucheggSettings.c"
}

MouseTouchpadToucheggSettings*
mouse_touchpad_touchegg_settings_new (void)
{
#line 38 "../src/Utils/ToucheggSettings.vala"
	return mouse_touchpad_touchegg_settings_construct (MOUSE_TOUCHPAD_TYPE_TOUCHEGG_SETTINGS);
#line 153 "ToucheggSettings.c"
}

gboolean
mouse_touchpad_touchegg_settings_is_installed (MouseTouchpadToucheggSettings* self)
{
	gboolean config_installed = FALSE;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
	GSettingsSchema* gala_schema = NULL;
	GSettingsSchemaSource* _tmp4_;
	GSettingsSchema* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean result;
#line 44 "../src/Utils/ToucheggSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../src/Utils/ToucheggSettings.vala"
	_tmp0_ = self->priv->system_config_path;
#line 45 "../src/Utils/ToucheggSettings.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 45 "../src/Utils/ToucheggSettings.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/Utils/ToucheggSettings.vala"
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 45 "../src/Utils/ToucheggSettings.vala"
	_g_object_unref0 (_tmp2_);
#line 45 "../src/Utils/ToucheggSettings.vala"
	config_installed = _tmp3_;
#line 46 "../src/Utils/ToucheggSettings.vala"
	_tmp4_ = g_settings_schema_source_get_default ();
#line 46 "../src/Utils/ToucheggSettings.vala"
	_tmp5_ = g_settings_schema_source_lookup (_tmp4_, "io.elementary.desktop.wm.gestures", FALSE);
#line 46 "../src/Utils/ToucheggSettings.vala"
	gala_schema = _tmp5_;
#line 47 "../src/Utils/ToucheggSettings.vala"
	if (config_installed) {
#line 191 "ToucheggSettings.c"
		GSettingsSchema* _tmp7_;
#line 47 "../src/Utils/ToucheggSettings.vala"
		_tmp7_ = gala_schema;
#line 47 "../src/Utils/ToucheggSettings.vala"
		_tmp6_ = _tmp7_ != NULL;
#line 197 "ToucheggSettings.c"
	} else {
#line 47 "../src/Utils/ToucheggSettings.vala"
		_tmp6_ = FALSE;
#line 201 "ToucheggSettings.c"
	}
#line 47 "../src/Utils/ToucheggSettings.vala"
	result = _tmp6_;
#line 47 "../src/Utils/ToucheggSettings.vala"
	_g_settings_schema_unref0 (gala_schema);
#line 47 "../src/Utils/ToucheggSettings.vala"
	return result;
#line 209 "ToucheggSettings.c"
}

void
mouse_touchpad_touchegg_settings_set_maximize_settings (MouseTouchpadToucheggSettings* self,
                                                        gboolean enabled,
                                                        gint fingers)
{
	gchar* xml_settings = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* xpath = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 50 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Utils/ToucheggSettings.vala"
	_tmp0_ = mouse_touchpad_touchegg_settings_build_maximize_xml (fingers);
#line 51 "../src/Utils/ToucheggSettings.vala"
	xml_settings = _tmp0_;
#line 52 "../src/Utils/ToucheggSettings.vala"
	if (fingers == 3) {
#line 52 "../src/Utils/ToucheggSettings.vala"
		_tmp1_ = MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_MAXIMIZE_3_XPATH;
#line 237 "ToucheggSettings.c"
	} else {
#line 52 "../src/Utils/ToucheggSettings.vala"
		_tmp1_ = MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_MAXIMIZE_4_XPATH;
#line 241 "ToucheggSettings.c"
	}
#line 52 "../src/Utils/ToucheggSettings.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "../src/Utils/ToucheggSettings.vala"
	xpath = _tmp2_;
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp3_ = xml_settings;
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp5_ = g_new0 (gchar*, 1 + 1);
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp5_[0] = _tmp4_;
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp6_ = _tmp5_;
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp6__length1 = 1;
#line 53 "../src/Utils/ToucheggSettings.vala"
	mouse_touchpad_touchegg_settings_save_config (self, xpath, enabled, _tmp6_, (gint) 1);
#line 53 "../src/Utils/ToucheggSettings.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 50 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (xpath);
#line 50 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (xml_settings);
#line 267 "ToucheggSettings.c"
}

static gboolean
mouse_touchpad_touchegg_settings_user_config_exists (MouseTouchpadToucheggSettings* self)
{
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 56 "../src/Utils/ToucheggSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/Utils/ToucheggSettings.vala"
	_tmp0_ = self->priv->user_config_path;
#line 57 "../src/Utils/ToucheggSettings.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 57 "../src/Utils/ToucheggSettings.vala"
	_tmp2_ = _tmp1_;
#line 57 "../src/Utils/ToucheggSettings.vala"
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 57 "../src/Utils/ToucheggSettings.vala"
	_g_object_unref0 (_tmp2_);
#line 57 "../src/Utils/ToucheggSettings.vala"
	result = _tmp3_;
#line 57 "../src/Utils/ToucheggSettings.vala"
	return result;
#line 294 "ToucheggSettings.c"
}

void
mouse_touchpad_touchegg_settings_parse_config (MouseTouchpadToucheggSettings* self)
{
	xmlDoc* doc = NULL;
	GError* _inner_error0_ = NULL;
#line 60 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Utils/ToucheggSettings.vala"
	doc = NULL;
#line 306 "ToucheggSettings.c"
	{
		const gchar* _tmp0_ = NULL;
		gchar* config_path = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		xmlDoc* _tmp5_;
		xmlDoc* _tmp6_;
		xmlXPathContext* ctx = NULL;
		xmlDoc* _tmp9_;
		xmlXPathContext* _tmp10_;
		xmlXPathContext* _tmp11_;
#line 64 "../src/Utils/ToucheggSettings.vala"
		if (mouse_touchpad_touchegg_settings_user_config_exists (self)) {
#line 320 "ToucheggSettings.c"
			const gchar* _tmp1_;
#line 65 "../src/Utils/ToucheggSettings.vala"
			_tmp1_ = self->priv->user_config_path;
#line 65 "../src/Utils/ToucheggSettings.vala"
			_tmp0_ = _tmp1_;
#line 326 "ToucheggSettings.c"
		} else {
			const gchar* _tmp2_;
#line 66 "../src/Utils/ToucheggSettings.vala"
			_tmp2_ = self->priv->system_config_path;
#line 66 "../src/Utils/ToucheggSettings.vala"
			_tmp0_ = _tmp2_;
#line 333 "ToucheggSettings.c"
		}
#line 64 "../src/Utils/ToucheggSettings.vala"
		_tmp3_ = g_strdup (_tmp0_);
#line 64 "../src/Utils/ToucheggSettings.vala"
		config_path = _tmp3_;
#line 67 "../src/Utils/ToucheggSettings.vala"
		_tmp4_ = config_path;
#line 67 "../src/Utils/ToucheggSettings.vala"
		_tmp5_ = xmlParseFile (_tmp4_);
#line 67 "../src/Utils/ToucheggSettings.vala"
		doc = _tmp5_;
#line 69 "../src/Utils/ToucheggSettings.vala"
		_tmp6_ = doc;
#line 69 "../src/Utils/ToucheggSettings.vala"
		if (_tmp6_ == NULL) {
#line 349 "ToucheggSettings.c"
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 70 "../src/Utils/ToucheggSettings.vala"
			_tmp7_ = config_path;
#line 70 "../src/Utils/ToucheggSettings.vala"
			_tmp8_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Error parsing config: %s", _tmp7_);
#line 70 "../src/Utils/ToucheggSettings.vala"
			_inner_error0_ = _tmp8_;
#line 70 "../src/Utils/ToucheggSettings.vala"
			_g_free0 (config_path);
#line 360 "ToucheggSettings.c"
			goto __catch0_g_error;
		}
#line 73 "../src/Utils/ToucheggSettings.vala"
		_tmp9_ = doc;
#line 73 "../src/Utils/ToucheggSettings.vala"
		_tmp10_ = xmlXPathNewContext (_tmp9_);
#line 73 "../src/Utils/ToucheggSettings.vala"
		ctx = _tmp10_;
#line 74 "../src/Utils/ToucheggSettings.vala"
		_tmp11_ = ctx;
#line 74 "../src/Utils/ToucheggSettings.vala"
		if (_tmp11_ == NULL) {
#line 373 "ToucheggSettings.c"
			GError* _tmp12_;
#line 75 "../src/Utils/ToucheggSettings.vala"
			_tmp12_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Error creating XPath context");
#line 75 "../src/Utils/ToucheggSettings.vala"
			_inner_error0_ = _tmp12_;
#line 75 "../src/Utils/ToucheggSettings.vala"
			_xmlXPathFreeContext0 (ctx);
#line 75 "../src/Utils/ToucheggSettings.vala"
			_g_free0 (config_path);
#line 383 "ToucheggSettings.c"
			goto __catch0_g_error;
		}
#line 78 "../src/Utils/ToucheggSettings.vala"
		mouse_touchpad_touchegg_settings_set_errors (self, FALSE);
#line 63 "../src/Utils/ToucheggSettings.vala"
		_xmlXPathFreeContext0 (ctx);
#line 63 "../src/Utils/ToucheggSettings.vala"
		_g_free0 (config_path);
#line 392 "ToucheggSettings.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 63 "../src/Utils/ToucheggSettings.vala"
		e = _inner_error0_;
#line 63 "../src/Utils/ToucheggSettings.vala"
		_inner_error0_ = NULL;
#line 80 "../src/Utils/ToucheggSettings.vala"
		_tmp13_ = e;
#line 80 "../src/Utils/ToucheggSettings.vala"
		_tmp14_ = _tmp13_->message;
#line 80 "../src/Utils/ToucheggSettings.vala"
		g_warning ("ToucheggSettings.vala:80: Error parsing Touchégg config: %s", _tmp14_);
#line 81 "../src/Utils/ToucheggSettings.vala"
		mouse_touchpad_touchegg_settings_set_errors (self, TRUE);
#line 63 "../src/Utils/ToucheggSettings.vala"
		_g_error_free0 (e);
#line 414 "ToucheggSettings.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		xmlDoc* _tmp15_;
#line 83 "../src/Utils/ToucheggSettings.vala"
		_tmp15_ = doc;
#line 83 "../src/Utils/ToucheggSettings.vala"
		if (_tmp15_ != NULL) {
#line 424 "ToucheggSettings.c"
			xmlDoc* _tmp16_;
#line 84 "../src/Utils/ToucheggSettings.vala"
			_tmp16_ = doc;
#line 84 "../src/Utils/ToucheggSettings.vala"
			_xmlFreeDoc0 (_tmp16_);
#line 430 "ToucheggSettings.c"
		}
	}
#line 63 "../src/Utils/ToucheggSettings.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/Utils/ToucheggSettings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../src/Utils/ToucheggSettings.vala"
		g_clear_error (&_inner_error0_);
#line 63 "../src/Utils/ToucheggSettings.vala"
		return;
#line 441 "ToucheggSettings.c"
	}
}

static void
mouse_touchpad_touchegg_settings_save_config (MouseTouchpadToucheggSettings* self,
                                              const gchar* xpath_expression,
                                              gboolean enabled,
                                              gchar** xml_settings,
                                              gint xml_settings_length1)
{
	xmlDoc* doc = NULL;
	GError* _inner_error0_ = NULL;
#line 89 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (xpath_expression != NULL);
#line 90 "../src/Utils/ToucheggSettings.vala"
	doc = NULL;
#line 460 "ToucheggSettings.c"
	{
		gchar* config_path = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		xmlDoc* _tmp10_;
		xmlDoc* _tmp11_;
		xmlXPathContext* ctx = NULL;
		xmlDoc* _tmp14_;
		xmlXPathContext* _tmp15_;
		xmlXPathContext* _tmp16_;
		xmlXPathContext* _tmp18_;
		xmlDoc* _tmp36_;
		const gchar* _tmp37_;
#line 93 "../src/Utils/ToucheggSettings.vala"
		if (!mouse_touchpad_touchegg_settings_user_config_exists (self)) {
#line 477 "ToucheggSettings.c"
			const gchar* _tmp0_;
			GFile* system_config_file = NULL;
			const gchar* _tmp1_;
			GFile* _tmp2_;
			GFile* home_config_file = NULL;
			const gchar* _tmp3_;
			GFile* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
#line 94 "../src/Utils/ToucheggSettings.vala"
			_tmp0_ = self->priv->user_config_dir_path;
#line 94 "../src/Utils/ToucheggSettings.vala"
			g_mkdir_with_parents (_tmp0_, 0775);
#line 95 "../src/Utils/ToucheggSettings.vala"
			_tmp1_ = self->priv->system_config_path;
#line 95 "../src/Utils/ToucheggSettings.vala"
			_tmp2_ = g_file_new_for_path (_tmp1_);
#line 95 "../src/Utils/ToucheggSettings.vala"
			system_config_file = _tmp2_;
#line 96 "../src/Utils/ToucheggSettings.vala"
			_tmp3_ = self->priv->user_config_path;
#line 96 "../src/Utils/ToucheggSettings.vala"
			_tmp4_ = g_file_new_for_path (_tmp3_);
#line 96 "../src/Utils/ToucheggSettings.vala"
			home_config_file = _tmp4_;
#line 97 "../src/Utils/ToucheggSettings.vala"
			_tmp5_ = system_config_file;
#line 97 "../src/Utils/ToucheggSettings.vala"
			_tmp6_ = home_config_file;
#line 97 "../src/Utils/ToucheggSettings.vala"
			g_file_copy (_tmp5_, _tmp6_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 97 "../src/Utils/ToucheggSettings.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/Utils/ToucheggSettings.vala"
				_g_object_unref0 (home_config_file);
#line 97 "../src/Utils/ToucheggSettings.vala"
				_g_object_unref0 (system_config_file);
#line 515 "ToucheggSettings.c"
				goto __catch0_g_error;
			}
#line 93 "../src/Utils/ToucheggSettings.vala"
			_g_object_unref0 (home_config_file);
#line 93 "../src/Utils/ToucheggSettings.vala"
			_g_object_unref0 (system_config_file);
#line 522 "ToucheggSettings.c"
		}
#line 100 "../src/Utils/ToucheggSettings.vala"
		_tmp7_ = self->priv->user_config_path;
#line 100 "../src/Utils/ToucheggSettings.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 100 "../src/Utils/ToucheggSettings.vala"
		config_path = _tmp8_;
#line 101 "../src/Utils/ToucheggSettings.vala"
		_tmp9_ = config_path;
#line 101 "../src/Utils/ToucheggSettings.vala"
		_tmp10_ = xmlParseFile (_tmp9_);
#line 101 "../src/Utils/ToucheggSettings.vala"
		doc = _tmp10_;
#line 103 "../src/Utils/ToucheggSettings.vala"
		_tmp11_ = doc;
#line 103 "../src/Utils/ToucheggSettings.vala"
		if (_tmp11_ == NULL) {
#line 540 "ToucheggSettings.c"
			const gchar* _tmp12_;
			GError* _tmp13_;
#line 104 "../src/Utils/ToucheggSettings.vala"
			_tmp12_ = config_path;
#line 104 "../src/Utils/ToucheggSettings.vala"
			_tmp13_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Error parsing config: %s", _tmp12_);
#line 104 "../src/Utils/ToucheggSettings.vala"
			_inner_error0_ = _tmp13_;
#line 104 "../src/Utils/ToucheggSettings.vala"
			_g_free0 (config_path);
#line 551 "ToucheggSettings.c"
			goto __catch0_g_error;
		}
#line 107 "../src/Utils/ToucheggSettings.vala"
		_tmp14_ = doc;
#line 107 "../src/Utils/ToucheggSettings.vala"
		_tmp15_ = xmlXPathNewContext (_tmp14_);
#line 107 "../src/Utils/ToucheggSettings.vala"
		ctx = _tmp15_;
#line 108 "../src/Utils/ToucheggSettings.vala"
		_tmp16_ = ctx;
#line 108 "../src/Utils/ToucheggSettings.vala"
		if (_tmp16_ == NULL) {
#line 564 "ToucheggSettings.c"
			GError* _tmp17_;
#line 109 "../src/Utils/ToucheggSettings.vala"
			_tmp17_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Error creating XPath context");
#line 109 "../src/Utils/ToucheggSettings.vala"
			_inner_error0_ = _tmp17_;
#line 109 "../src/Utils/ToucheggSettings.vala"
			_xmlXPathFreeContext0 (ctx);
#line 109 "../src/Utils/ToucheggSettings.vala"
			_g_free0 (config_path);
#line 574 "ToucheggSettings.c"
			goto __catch0_g_error;
		}
#line 112 "../src/Utils/ToucheggSettings.vala"
		_tmp18_ = ctx;
#line 112 "../src/Utils/ToucheggSettings.vala"
		mouse_touchpad_touchegg_settings_remove_matching_nodes (_tmp18_, xpath_expression);
#line 114 "../src/Utils/ToucheggSettings.vala"
		if (enabled) {
#line 583 "ToucheggSettings.c"
			xmlXPathObject* obj = NULL;
			xmlXPathContext* _tmp19_;
			xmlXPathObject* _tmp20_;
			xmlXPathObject* _tmp21_;
			gboolean _tmp23_ = FALSE;
			xmlXPathObject* _tmp24_;
			xmlNodeSet* _tmp25_;
			xmlXPathObject* _tmp35_;
#line 115 "../src/Utils/ToucheggSettings.vala"
			_tmp19_ = ctx;
#line 115 "../src/Utils/ToucheggSettings.vala"
			_tmp20_ = xmlXPathEvalExpression ((xmlChar*) MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_SETTINGS_XPATH, _tmp19_);
#line 115 "../src/Utils/ToucheggSettings.vala"
			obj = _tmp20_;
#line 116 "../src/Utils/ToucheggSettings.vala"
			_tmp21_ = obj;
#line 116 "../src/Utils/ToucheggSettings.vala"
			if (_tmp21_ == NULL) {
#line 602 "ToucheggSettings.c"
				GError* _tmp22_;
#line 117 "../src/Utils/ToucheggSettings.vala"
				_tmp22_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "XPath %s not found", MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_SETTINGS_XPATH);
#line 117 "../src/Utils/ToucheggSettings.vala"
				_inner_error0_ = _tmp22_;
#line 117 "../src/Utils/ToucheggSettings.vala"
				_xmlXPathFreeContext0 (ctx);
#line 117 "../src/Utils/ToucheggSettings.vala"
				_g_free0 (config_path);
#line 612 "ToucheggSettings.c"
				goto __catch0_g_error;
			}
#line 120 "../src/Utils/ToucheggSettings.vala"
			_tmp24_ = obj;
#line 120 "../src/Utils/ToucheggSettings.vala"
			_tmp25_ = _tmp24_->nodesetval;
#line 120 "../src/Utils/ToucheggSettings.vala"
			if (_tmp25_ != NULL) {
#line 621 "ToucheggSettings.c"
				xmlXPathObject* _tmp26_;
				xmlNodeSet* _tmp27_;
				xmlNode* _tmp28_;
#line 120 "../src/Utils/ToucheggSettings.vala"
				_tmp26_ = obj;
#line 120 "../src/Utils/ToucheggSettings.vala"
				_tmp27_ = _tmp26_->nodesetval;
#line 120 "../src/Utils/ToucheggSettings.vala"
				_tmp28_ = xmlXPathNodeSetItem (_tmp27_, 0);
#line 120 "../src/Utils/ToucheggSettings.vala"
				_tmp23_ = _tmp28_ != NULL;
#line 633 "ToucheggSettings.c"
			} else {
#line 120 "../src/Utils/ToucheggSettings.vala"
				_tmp23_ = FALSE;
#line 637 "ToucheggSettings.c"
			}
#line 120 "../src/Utils/ToucheggSettings.vala"
			if (_tmp23_) {
#line 641 "ToucheggSettings.c"
				xmlNode* node = NULL;
				xmlXPathObject* _tmp29_;
				xmlNodeSet* _tmp30_;
				xmlNode* _tmp31_;
#line 121 "../src/Utils/ToucheggSettings.vala"
				_tmp29_ = obj;
#line 121 "../src/Utils/ToucheggSettings.vala"
				_tmp30_ = _tmp29_->nodesetval;
#line 121 "../src/Utils/ToucheggSettings.vala"
				_tmp31_ = xmlXPathNodeSetItem (_tmp30_, 0);
#line 121 "../src/Utils/ToucheggSettings.vala"
				node = _tmp31_;
#line 654 "ToucheggSettings.c"
				{
					gchar** xml_collection = NULL;
					gint xml_collection_length1 = 0;
					gint _xml_collection_size_ = 0;
					gint xml_it = 0;
#line 122 "../src/Utils/ToucheggSettings.vala"
					xml_collection = xml_settings;
#line 122 "../src/Utils/ToucheggSettings.vala"
					xml_collection_length1 = xml_settings_length1;
#line 122 "../src/Utils/ToucheggSettings.vala"
					for (xml_it = 0; xml_it < xml_collection_length1; xml_it = xml_it + 1) {
#line 666 "ToucheggSettings.c"
						gchar* _tmp32_;
						gchar* xml = NULL;
#line 122 "../src/Utils/ToucheggSettings.vala"
						_tmp32_ = g_strdup (xml_collection[xml_it]);
#line 122 "../src/Utils/ToucheggSettings.vala"
						xml = _tmp32_;
#line 673 "ToucheggSettings.c"
						{
							xmlNode* _tmp33_;
							const gchar* _tmp34_;
#line 123 "../src/Utils/ToucheggSettings.vala"
							_tmp33_ = node;
#line 123 "../src/Utils/ToucheggSettings.vala"
							_tmp34_ = xml;
#line 123 "../src/Utils/ToucheggSettings.vala"
							mouse_touchpad_touchegg_settings_append_xml (_tmp33_, _tmp34_, &_inner_error0_);
#line 123 "../src/Utils/ToucheggSettings.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/Utils/ToucheggSettings.vala"
								_g_free0 (xml);
#line 123 "../src/Utils/ToucheggSettings.vala"
								_xmlXPathFreeContext0 (ctx);
#line 123 "../src/Utils/ToucheggSettings.vala"
								_g_free0 (config_path);
#line 691 "ToucheggSettings.c"
								goto __catch0_g_error;
							}
#line 122 "../src/Utils/ToucheggSettings.vala"
							_g_free0 (xml);
#line 696 "ToucheggSettings.c"
						}
					}
				}
			}
#line 127 "../src/Utils/ToucheggSettings.vala"
			_tmp35_ = obj;
#line 127 "../src/Utils/ToucheggSettings.vala"
			_xmlXPathFreeObject0 (_tmp35_);
#line 705 "ToucheggSettings.c"
		}
#line 130 "../src/Utils/ToucheggSettings.vala"
		_tmp36_ = doc;
#line 130 "../src/Utils/ToucheggSettings.vala"
		_tmp37_ = config_path;
#line 130 "../src/Utils/ToucheggSettings.vala"
		xmlSaveFile (_tmp37_, _tmp36_);
#line 131 "../src/Utils/ToucheggSettings.vala"
		mouse_touchpad_touchegg_settings_set_errors (self, FALSE);
#line 92 "../src/Utils/ToucheggSettings.vala"
		_xmlXPathFreeContext0 (ctx);
#line 92 "../src/Utils/ToucheggSettings.vala"
		_g_free0 (config_path);
#line 719 "ToucheggSettings.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp38_;
		const gchar* _tmp39_;
#line 92 "../src/Utils/ToucheggSettings.vala"
		e = _inner_error0_;
#line 92 "../src/Utils/ToucheggSettings.vala"
		_inner_error0_ = NULL;
#line 133 "../src/Utils/ToucheggSettings.vala"
		_tmp38_ = e;
#line 133 "../src/Utils/ToucheggSettings.vala"
		_tmp39_ = _tmp38_->message;
#line 133 "../src/Utils/ToucheggSettings.vala"
		g_warning ("ToucheggSettings.vala:133: Error saving Touchégg config: %s", _tmp39_);
#line 134 "../src/Utils/ToucheggSettings.vala"
		mouse_touchpad_touchegg_settings_set_errors (self, TRUE);
#line 92 "../src/Utils/ToucheggSettings.vala"
		_g_error_free0 (e);
#line 741 "ToucheggSettings.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		xmlDoc* _tmp40_;
#line 136 "../src/Utils/ToucheggSettings.vala"
		_tmp40_ = doc;
#line 136 "../src/Utils/ToucheggSettings.vala"
		if (_tmp40_ != NULL) {
#line 751 "ToucheggSettings.c"
			xmlDoc* _tmp41_;
#line 137 "../src/Utils/ToucheggSettings.vala"
			_tmp41_ = doc;
#line 137 "../src/Utils/ToucheggSettings.vala"
			_xmlFreeDoc0 (_tmp41_);
#line 757 "ToucheggSettings.c"
		}
	}
#line 92 "../src/Utils/ToucheggSettings.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../src/Utils/ToucheggSettings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/Utils/ToucheggSettings.vala"
		g_clear_error (&_inner_error0_);
#line 92 "../src/Utils/ToucheggSettings.vala"
		return;
#line 768 "ToucheggSettings.c"
	}
}

static void
mouse_touchpad_touchegg_settings_remove_matching_nodes (xmlXPathContext* ctx,
                                                        const gchar* xpath_expression)
{
	gboolean done = FALSE;
#line 142 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (ctx != NULL);
#line 142 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (xpath_expression != NULL);
#line 143 "../src/Utils/ToucheggSettings.vala"
	done = FALSE;
#line 144 "../src/Utils/ToucheggSettings.vala"
	while (TRUE) {
#line 785 "ToucheggSettings.c"
		xmlXPathObject* obj = NULL;
		xmlXPathObject* _tmp0_;
		xmlXPathObject* _tmp1_;
#line 144 "../src/Utils/ToucheggSettings.vala"
		if (!(!done)) {
#line 144 "../src/Utils/ToucheggSettings.vala"
			break;
#line 793 "ToucheggSettings.c"
		}
#line 145 "../src/Utils/ToucheggSettings.vala"
		_tmp0_ = xmlXPathEvalExpression ((xmlChar*) xpath_expression, ctx);
#line 145 "../src/Utils/ToucheggSettings.vala"
		obj = _tmp0_;
#line 146 "../src/Utils/ToucheggSettings.vala"
		_tmp1_ = obj;
#line 146 "../src/Utils/ToucheggSettings.vala"
		if (_tmp1_ != NULL) {
#line 803 "ToucheggSettings.c"
			gboolean _tmp2_ = FALSE;
			xmlXPathObject* _tmp3_;
			xmlNodeSet* _tmp4_;
			xmlXPathObject* _tmp13_;
#line 147 "../src/Utils/ToucheggSettings.vala"
			_tmp3_ = obj;
#line 147 "../src/Utils/ToucheggSettings.vala"
			_tmp4_ = _tmp3_->nodesetval;
#line 147 "../src/Utils/ToucheggSettings.vala"
			if (_tmp4_ != NULL) {
#line 814 "ToucheggSettings.c"
				xmlXPathObject* _tmp5_;
				xmlNodeSet* _tmp6_;
				xmlNode* _tmp7_;
#line 147 "../src/Utils/ToucheggSettings.vala"
				_tmp5_ = obj;
#line 147 "../src/Utils/ToucheggSettings.vala"
				_tmp6_ = _tmp5_->nodesetval;
#line 147 "../src/Utils/ToucheggSettings.vala"
				_tmp7_ = xmlXPathNodeSetItem (_tmp6_, 0);
#line 147 "../src/Utils/ToucheggSettings.vala"
				_tmp2_ = _tmp7_ != NULL;
#line 826 "ToucheggSettings.c"
			} else {
#line 147 "../src/Utils/ToucheggSettings.vala"
				_tmp2_ = FALSE;
#line 830 "ToucheggSettings.c"
			}
#line 147 "../src/Utils/ToucheggSettings.vala"
			if (_tmp2_) {
#line 834 "ToucheggSettings.c"
				xmlNode* node = NULL;
				xmlXPathObject* _tmp8_;
				xmlNodeSet* _tmp9_;
				xmlNode* _tmp10_;
				xmlNode* _tmp11_;
				xmlNode* _tmp12_;
#line 148 "../src/Utils/ToucheggSettings.vala"
				_tmp8_ = obj;
#line 148 "../src/Utils/ToucheggSettings.vala"
				_tmp9_ = _tmp8_->nodesetval;
#line 148 "../src/Utils/ToucheggSettings.vala"
				_tmp10_ = xmlXPathNodeSetItem (_tmp9_, 0);
#line 148 "../src/Utils/ToucheggSettings.vala"
				node = _tmp10_;
#line 149 "../src/Utils/ToucheggSettings.vala"
				_tmp11_ = node;
#line 149 "../src/Utils/ToucheggSettings.vala"
				xmlUnlinkNode (_tmp11_);
#line 150 "../src/Utils/ToucheggSettings.vala"
				_tmp12_ = node;
#line 150 "../src/Utils/ToucheggSettings.vala"
				_xmlFreeNode0 (_tmp12_);
#line 857 "ToucheggSettings.c"
			} else {
#line 152 "../src/Utils/ToucheggSettings.vala"
				done = TRUE;
#line 861 "ToucheggSettings.c"
			}
#line 155 "../src/Utils/ToucheggSettings.vala"
			_tmp13_ = obj;
#line 155 "../src/Utils/ToucheggSettings.vala"
			_xmlXPathFreeObject0 (_tmp13_);
#line 867 "ToucheggSettings.c"
		} else {
#line 157 "../src/Utils/ToucheggSettings.vala"
			done = TRUE;
#line 871 "ToucheggSettings.c"
		}
	}
}

static void
mouse_touchpad_touchegg_settings_append_xml (xmlNode* node,
                                             const gchar* xml,
                                             GError** error)
{
	xmlDoc* doc = NULL;
	gint _tmp0_;
	gint _tmp1_;
	xmlDoc* _tmp2_;
	xmlDoc* _tmp3_;
	xmlNode* root = NULL;
	xmlDoc* _tmp5_;
	xmlNode* _tmp6_;
	xmlDoc* _tmp7_;
	xmlNode* _tmp8_;
	xmlNode* _tmp9_;
	xmlNode* _tmp12_;
	xmlDoc* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 162 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (xml != NULL);
#line 163 "../src/Utils/ToucheggSettings.vala"
	_tmp0_ = strlen (xml);
#line 163 "../src/Utils/ToucheggSettings.vala"
	_tmp1_ = _tmp0_;
#line 163 "../src/Utils/ToucheggSettings.vala"
	_tmp2_ = xmlReadMemory (xml, _tmp1_, NULL, NULL, 0);
#line 163 "../src/Utils/ToucheggSettings.vala"
	doc = _tmp2_;
#line 164 "../src/Utils/ToucheggSettings.vala"
	_tmp3_ = doc;
#line 164 "../src/Utils/ToucheggSettings.vala"
	if (_tmp3_ == NULL) {
#line 909 "ToucheggSettings.c"
		GError* _tmp4_;
#line 165 "../src/Utils/ToucheggSettings.vala"
		_tmp4_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Error parsing XML string: %s", xml);
#line 165 "../src/Utils/ToucheggSettings.vala"
		_inner_error0_ = _tmp4_;
#line 165 "../src/Utils/ToucheggSettings.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 165 "../src/Utils/ToucheggSettings.vala"
			g_propagate_error (error, _inner_error0_);
#line 165 "../src/Utils/ToucheggSettings.vala"
			return;
#line 921 "ToucheggSettings.c"
		} else {
#line 165 "../src/Utils/ToucheggSettings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/Utils/ToucheggSettings.vala"
			g_clear_error (&_inner_error0_);
#line 165 "../src/Utils/ToucheggSettings.vala"
			return;
#line 929 "ToucheggSettings.c"
		}
	}
#line 168 "../src/Utils/ToucheggSettings.vala"
	_tmp5_ = doc;
#line 168 "../src/Utils/ToucheggSettings.vala"
	_tmp6_ = xmlDocGetRootElement (_tmp5_);
#line 168 "../src/Utils/ToucheggSettings.vala"
	_tmp7_ = node->doc;
#line 168 "../src/Utils/ToucheggSettings.vala"
	_tmp8_ = xmlDocCopyNode (_tmp6_, _tmp7_, 1);
#line 168 "../src/Utils/ToucheggSettings.vala"
	root = _tmp8_;
#line 169 "../src/Utils/ToucheggSettings.vala"
	_tmp9_ = root;
#line 169 "../src/Utils/ToucheggSettings.vala"
	if (_tmp9_ == NULL) {
#line 946 "ToucheggSettings.c"
		xmlDoc* _tmp10_;
		GError* _tmp11_;
#line 170 "../src/Utils/ToucheggSettings.vala"
		_tmp10_ = doc;
#line 170 "../src/Utils/ToucheggSettings.vala"
		_xmlFreeDoc0 (_tmp10_);
#line 171 "../src/Utils/ToucheggSettings.vala"
		_tmp11_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Error getting root element of XML string: %s", xml);
#line 171 "../src/Utils/ToucheggSettings.vala"
		_inner_error0_ = _tmp11_;
#line 171 "../src/Utils/ToucheggSettings.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 171 "../src/Utils/ToucheggSettings.vala"
			g_propagate_error (error, _inner_error0_);
#line 171 "../src/Utils/ToucheggSettings.vala"
			return;
#line 963 "ToucheggSettings.c"
		} else {
#line 171 "../src/Utils/ToucheggSettings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/Utils/ToucheggSettings.vala"
			g_clear_error (&_inner_error0_);
#line 171 "../src/Utils/ToucheggSettings.vala"
			return;
#line 971 "ToucheggSettings.c"
		}
	}
#line 174 "../src/Utils/ToucheggSettings.vala"
	_tmp12_ = root;
#line 174 "../src/Utils/ToucheggSettings.vala"
	xmlAddChild (node, _tmp12_);
#line 175 "../src/Utils/ToucheggSettings.vala"
	_tmp13_ = doc;
#line 175 "../src/Utils/ToucheggSettings.vala"
	_xmlFreeDoc0 (_tmp13_);
#line 982 "ToucheggSettings.c"
}

static gchar*
mouse_touchpad_touchegg_settings_build_maximize_xml (gint fingers)
{
	gchar* _tmp0_;
	gchar* result;
#line 179 "../src/Utils/ToucheggSettings.vala"
	_tmp0_ = g_strdup_printf ("\n" \
"            <gesture type=\"SWIPE\" fingers=\"%d\" direction=\"UP\">\n" \
"                <action type=\"MAXIMIZE_RESTORE_WINDOW\">\n" \
"                    <animate>true</animate>\n" \
"                </action>\n" \
"            </gesture>\n" \
"        ", fingers);
#line 179 "../src/Utils/ToucheggSettings.vala"
	result = _tmp0_;
#line 179 "../src/Utils/ToucheggSettings.vala"
	return result;
#line 996 "ToucheggSettings.c"
}

gboolean
mouse_touchpad_touchegg_settings_get_errors (MouseTouchpadToucheggSettings* self)
{
	gboolean result;
#line 28 "../src/Utils/ToucheggSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/Utils/ToucheggSettings.vala"
	result = self->priv->_errors;
#line 28 "../src/Utils/ToucheggSettings.vala"
	return result;
#line 1009 "ToucheggSettings.c"
}

static void
mouse_touchpad_touchegg_settings_set_errors (MouseTouchpadToucheggSettings* self,
                                             gboolean value)
{
	gboolean old_value;
#line 28 "../src/Utils/ToucheggSettings.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Utils/ToucheggSettings.vala"
	old_value = mouse_touchpad_touchegg_settings_get_errors (self);
#line 28 "../src/Utils/ToucheggSettings.vala"
	if (old_value != value) {
#line 28 "../src/Utils/ToucheggSettings.vala"
		self->priv->_errors = value;
#line 28 "../src/Utils/ToucheggSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, mouse_touchpad_touchegg_settings_properties[MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_ERRORS_PROPERTY]);
#line 1027 "ToucheggSettings.c"
	}
}

static void
mouse_touchpad_touchegg_settings_class_init (MouseTouchpadToucheggSettingsClass * klass,
                                             gpointer klass_data)
{
#line 27 "../src/Utils/ToucheggSettings.vala"
	mouse_touchpad_touchegg_settings_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Utils/ToucheggSettings.vala"
	g_type_class_adjust_private_offset (klass, &MouseTouchpadToucheggSettings_private_offset);
#line 27 "../src/Utils/ToucheggSettings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_mouse_touchpad_touchegg_settings_get_property;
#line 27 "../src/Utils/ToucheggSettings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_mouse_touchpad_touchegg_settings_set_property;
#line 27 "../src/Utils/ToucheggSettings.vala"
	G_OBJECT_CLASS (klass)->finalize = mouse_touchpad_touchegg_settings_finalize;
#line 27 "../src/Utils/ToucheggSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_ERRORS_PROPERTY, mouse_touchpad_touchegg_settings_properties[MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_ERRORS_PROPERTY] = g_param_spec_boolean ("errors", "errors", "errors", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1047 "ToucheggSettings.c"
}

static void
mouse_touchpad_touchegg_settings_instance_init (MouseTouchpadToucheggSettings * self,
                                                gpointer klass)
{
#line 27 "../src/Utils/ToucheggSettings.vala"
	self->priv = mouse_touchpad_touchegg_settings_get_instance_private (self);
#line 28 "../src/Utils/ToucheggSettings.vala"
	self->priv->_errors = FALSE;
#line 1058 "ToucheggSettings.c"
}

static void
mouse_touchpad_touchegg_settings_finalize (GObject * obj)
{
	MouseTouchpadToucheggSettings * self;
#line 27 "../src/Utils/ToucheggSettings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MOUSE_TOUCHPAD_TYPE_TOUCHEGG_SETTINGS, MouseTouchpadToucheggSettings);
#line 30 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (self->priv->system_config_path);
#line 31 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (self->priv->user_config_dir_path);
#line 32 "../src/Utils/ToucheggSettings.vala"
	_g_free0 (self->priv->user_config_path);
#line 27 "../src/Utils/ToucheggSettings.vala"
	G_OBJECT_CLASS (mouse_touchpad_touchegg_settings_parent_class)->finalize (obj);
#line 1075 "ToucheggSettings.c"
}

/**
 * Utility class to configure Touchégg based gestures.
 */
static GType
mouse_touchpad_touchegg_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MouseTouchpadToucheggSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mouse_touchpad_touchegg_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MouseTouchpadToucheggSettings), 0, (GInstanceInitFunc) mouse_touchpad_touchegg_settings_instance_init, NULL };
	GType mouse_touchpad_touchegg_settings_type_id;
	mouse_touchpad_touchegg_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "MouseTouchpadToucheggSettings", &g_define_type_info, 0);
	MouseTouchpadToucheggSettings_private_offset = g_type_add_instance_private (mouse_touchpad_touchegg_settings_type_id, sizeof (MouseTouchpadToucheggSettingsPrivate));
	return mouse_touchpad_touchegg_settings_type_id;
}

GType
mouse_touchpad_touchegg_settings_get_type (void)
{
	static volatile gsize mouse_touchpad_touchegg_settings_type_id__once = 0;
	if (g_once_init_enter (&mouse_touchpad_touchegg_settings_type_id__once)) {
		GType mouse_touchpad_touchegg_settings_type_id;
		mouse_touchpad_touchegg_settings_type_id = mouse_touchpad_touchegg_settings_get_type_once ();
		g_once_init_leave (&mouse_touchpad_touchegg_settings_type_id__once, mouse_touchpad_touchegg_settings_type_id);
	}
	return mouse_touchpad_touchegg_settings_type_id__once;
}

static void
_vala_mouse_touchpad_touchegg_settings_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	MouseTouchpadToucheggSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MOUSE_TOUCHPAD_TYPE_TOUCHEGG_SETTINGS, MouseTouchpadToucheggSettings);
#line 27 "../src/Utils/ToucheggSettings.vala"
	switch (property_id) {
#line 27 "../src/Utils/ToucheggSettings.vala"
		case MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_ERRORS_PROPERTY:
#line 27 "../src/Utils/ToucheggSettings.vala"
		g_value_set_boolean (value, mouse_touchpad_touchegg_settings_get_errors (self));
#line 27 "../src/Utils/ToucheggSettings.vala"
		break;
#line 1119 "ToucheggSettings.c"
		default:
#line 27 "../src/Utils/ToucheggSettings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Utils/ToucheggSettings.vala"
		break;
#line 1125 "ToucheggSettings.c"
	}
}

static void
_vala_mouse_touchpad_touchegg_settings_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	MouseTouchpadToucheggSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MOUSE_TOUCHPAD_TYPE_TOUCHEGG_SETTINGS, MouseTouchpadToucheggSettings);
#line 27 "../src/Utils/ToucheggSettings.vala"
	switch (property_id) {
#line 27 "../src/Utils/ToucheggSettings.vala"
		case MOUSE_TOUCHPAD_TOUCHEGG_SETTINGS_ERRORS_PROPERTY:
#line 27 "../src/Utils/ToucheggSettings.vala"
		mouse_touchpad_touchegg_settings_set_errors (self, g_value_get_boolean (value));
#line 27 "../src/Utils/ToucheggSettings.vala"
		break;
#line 1145 "ToucheggSettings.c"
		default:
#line 27 "../src/Utils/ToucheggSettings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Utils/ToucheggSettings.vala"
		break;
#line 1151 "ToucheggSettings.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

